﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace GetJobLedgerEntryExample
{
    class Program
    {
        static string  sURI = "https://secureapi.smarttid.dk/wsAPISmartTID.asmx";
        static void Main(string[] args)
        {
            string sAPIKey = "XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX"; //this must be replaced with a valid APIKey
            GetJobLedgerEntry(sAPIKey);
        }
        private static void GetJobLedgerEntry(string sAPIKey)
        {

            using (var client = new HttpClient())
            {
                var request = new HttpRequestMessage()
                {
                    RequestUri = new Uri(sURI),
                    Method = HttpMethod.Post
                };

                request.Content = new StringContent(GetJobLedgerEntrySOAPString(sAPIKey), Encoding.UTF8, "text/xml");

                request.Headers.Clear();
                client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("text/xml"));
                request.Content.Headers.ContentType = new MediaTypeHeaderValue("text/xml");
                request.Headers.Add("SOAPAction", "http://api.smarttid.dk/GetJobLedgerEntry");

                HttpResponseMessage response = client.SendAsync(request).Result;

                if (!response.IsSuccessStatusCode)
                {
                    throw new Exception();
                }

                Task<Stream> streamTask = response.Content.ReadAsStreamAsync();
                Stream stream = streamTask.Result;
                StreamReader reader = new StreamReader(stream);
                string str = reader.ReadToEnd();
                Console.WriteLine(str);
                Console.ReadLine();

            }

        }
        private static string GetJobLedgerEntrySOAPString(string strAPIKey)
        {

            string startSoapEnvelopeString = @"<?xml version=""1.0"" encoding=""utf-8""?>
                                    <soap:Envelope xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"" xmlns:soap=""http://schemas.xmlsoap.org/soap/envelope/"">
                                    <soap:Body>";
            string parameterString = @"<GetJobLedgerEntry xmlns=""http://api.smarttid.dk/"">";
            if (strAPIKey != "")
            {
                parameterString = parameterString + "<sAPIKey>" + strAPIKey + "</sAPIKey>";
            }
            parameterString = parameterString + "</GetJobLedgerEntry>";

            string endSoapEnvelopeString = "</soap:Body></soap:Envelope>";
            string argumentString = startSoapEnvelopeString + parameterString + endSoapEnvelopeString;
            return argumentString;
        }
       
    }
}
